var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  BookType: () => BookType,
  default: () => stdin_default,
  myApiClient: () => myApiClient
});
module.exports = __toCommonJS(stdin_exports);
var import_endpoint = require("./endpoint");
var import_standalone = require("prettier/standalone");
var import_parser_graphql = __toESM(require("prettier/parser-graphql"));
const formatGraphQL = (query) => (0, import_standalone.format)(query, { parser: "graphql", plugins: [import_parser_graphql.default] });
const BookType = {
  dolor: "DOLOR",
  ipsum: "IPSUM",
  sit: "SIT"
};
const typesTree = {
  Query: {
    get booksWithOptionalParams() {
      return {
        __args: {
          params: "BookSearchParamsAllOptional!"
        }
      };
    },
    get booksWithRequiredParams() {
      return {
        __args: {
          params: "BookSearchParamsSomeRequired!"
        }
      };
    },
    get failingQuery() {
      return {
        __args: {
          id: "String!"
        }
      };
    },
    booksWithoutParams: {}
  }
};
let verbose = false;
let headers = {};
let url = "http://localhost:4123/graphql";
let retryConfig = {
  max: 0,
  before: void 0,
  waitBeforeRetry: 0
};
let responseListeners = [];
let apiEndpoint = (0, import_endpoint.getApiEndpointCreator)({
  getClient: () => ({ url, headers, retryConfig }),
  responseListeners,
  maxAge: 3e4,
  verbose,
  typesTree,
  formatGraphQL
});
const myApiClient = {
  addResponseListener: (listener) => responseListeners.push(
    listener
  ),
  setHeader: (key, value) => {
    headers[key] = value;
  },
  setHeaders: (newHeaders) => {
    headers = newHeaders;
  },
  setRetryConfig: (options) => {
    if (!Number.isInteger(options.max) || options.max < 0) {
      throw new Error("retryOptions.max should be a non-negative integer");
    }
    retryConfig = {
      max: options.max,
      waitBeforeRetry: options.waitBeforeRetry,
      before: options.before
    };
  },
  setUrl: (_url) => url = _url,
  queries: {
    booksWithoutParams: apiEndpoint("query", "booksWithoutParams"),
    booksWithOptionalParams: apiEndpoint("query", "booksWithOptionalParams"),
    booksWithRequiredParams: apiEndpoint("query", "booksWithRequiredParams"),
    failingQuery: apiEndpoint("query", "failingQuery")
  },
  mutations: {}
};
var stdin_default = myApiClient;
